-- Request Table
------------------------------------
--jemser_product_id
--qty
--jemser_project_id
--response_deadline
--completion_date 
--responder_business_entity_id
--parent_request_id
--initial_creation_date
--request_reference text 
--rate 

ALTER TABLE request
  ADD COLUMN jemser_product_id integer;
ALTER TABLE request
  ADD COLUMN jemser_product_qty numeric(10,2);
ALTER TABLE request
  ADD COLUMN jemser_project_id integer;
ALTER TABLE request
  ADD COLUMN response_deadline timestamp with time zone;
ALTER TABLE request
  ADD COLUMN completion_date timestamp with time zone;
ALTER TABLE request
  ADD COLUMN responder_business_entity_id integer;
ALTER TABLE request
  ADD COLUMN parent_request_id integer;
ALTER TABLE request
  ADD COLUMN initial_creation_date timestamp with time zone;
ALTER TABLE request
  ADD COLUMN request_reference text;
ALTER TABLE request  ADD COLUMN rate numeric(10,4);
ALTER TABLE request
  ADD CONSTRAINT request_jemser_product_fk FOREIGN KEY (jemser_product_id) REFERENCES jemser_product (id) ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE request
  ADD CONSTRAINT request_jemser_project_fk FOREIGN KEY (jemser_project_id) REFERENCES jemser_project (id) ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE request
  ADD CONSTRAINT request_responder_business_entity_fk FOREIGN KEY (responder_business_entity_id) REFERENCES business_entity (id) ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE request
  ADD CONSTRAINT request_parent_request_fk FOREIGN KEY (parent_request_id) REFERENCES request (id) ON UPDATE NO ACTION ON DELETE NO ACTION;


ALTER TABLE request RENAME rate  TO daily_rate;
ALTER TABLE request
  ADD COLUMN weekly_rate numeric(10,4);
ALTER TABLE request
  ADD COLUMN sales numeric(10,4);
 
-- Jemser_action
------------------------------------
-- responder_business_entity_id

ALTER TABLE jemser_action
  ADD COLUMN responder_business_entity_id integer;
ALTER TABLE jemser_action
  ADD CONSTRAINT jemser_action_responder_business_entity_fk FOREIGN KEY (responder_business_entity_id) REFERENCES business_entity (id) ON UPDATE NO ACTION ON DELETE NO ACTION;

 

 
-- business_entity_relationship
------------------------------------
ALTER TABLE business_entity_relationship ADD COLUMN seq integer;

-- jemser_tender
------------------------------------
ALTER TABLE jemser_tender
  ADD COLUMN business_entity_relationship_id integer;
ALTER TABLE jemser_tender
  ADD CONSTRAINT business_entity_relationship_fk FOREIGN KEY (business_entity_relationship_id) REFERENCES business_entity_relationship (id) ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE jemser_tender
  ADD COLUMN seq integer;
  
-- Jemser_product


ALTER TABLE jemser_product ALTER COLUMN jemser_product_id DROP NOT NULL;
ALTER TABLE jemser_product ALTER COLUMN optlock DROP NOT NULL;



-- Product GROUP
ALTER TABLE product_group  ALTER COLUMN product_group_id DROP NOT NULL;
ALTER TABLE product_group  ALTER COLUMN optlock DROP NOT NULL;


--Jemser_project

ALTER TABLE jemser_project ALTER COLUMN optlock DROP NOT NULL;

-- business_entity_product

drop table business_entity_product;
CREATE TABLE business_entity_product
(
  id serial NOT NULL,
  business_entity_id integer NOT NULL,
  optlock integer NOT NULL DEFAULT 0,
  jemser_product_id integer NOT NULL,
  lft integer,
  rgt integer,
  CONSTRAINT business_entity_product_pk PRIMARY KEY (id),
  CONSTRAINT business_entity_product_business_entity_fk FOREIGN KEY (business_entity_id)
      REFERENCES business_entity (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE business_entity_product
  OWNER TO postgres;

-- Index: bus_prod_celko

-- DROP INDEX bus_prod_celko;

CREATE INDEX bus_prod_celko
  ON business_entity_product
  USING btree
  (lft, rgt);


ALTER TABLE business_entity_product  ADD CONSTRAINT business_entity_product_to_jp_fk FOREIGN KEY (jemser_product_id) REFERENCES jemser_product (id) ON UPDATE NO ACTION ON DELETE NO ACTION;


-- request rating
CREATE TABLE request_rating
(
  id serial NOT NULL,
  business_entity_id integer,
  request_id integer,
  punctuality_rating integer,
  equipment_condition_rating integer,
  equipment_accuracy_rating integer,
  comment text,
  CONSTRAINT request_rating_pk PRIMARY KEY (id),
  CONSTRAINT rr_to_business_entity_fk FOREIGN KEY (business_entity_id)
      REFERENCES business_entity (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT rr_to_request_fk FOREIGN KEY (request_id)
      REFERENCES request (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE request_rating
  OWNER TO postgres;

-- jemser product , add class to it
 ALTER TABLE jemser_product
  ADD COLUMN product_class_id integer;
ALTER TABLE jemser_product
  ADD CONSTRAINT jp_to_product_class_fk FOREIGN KEY (product_class_id) REFERENCES product_class (id) ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE jemser_product
  ADD COLUMN cod text;
ALTER TABLE product_group
   ALTER COLUMN product_group_id DROP NOT NULL;


-- jemser product to easi hire product mapping
CREATE TABLE public.jemser_product_to_hire_or_product_map
(
   id serial, 
   jemser_product_id integer, 
   product_type_id integer, 
   pdesc_id integer,
   business_entity_id integer,
   singles_id integer,
   CONSTRAINT jp_to_h_or_p_pk PRIMARY KEY (id)
) 
WITH (
  OIDS = FALSE
)
;

ALTER TABLE business_entity_to_cust_map
  ADD COLUMN company_entity_id integer;
ALTER TABLE person_to_contact_map
  ADD COLUMN company_entity_id integer;
   ALTER TABLE address_to_custsite_map
  ADD COLUMN company_entity_id integer;
  
  
  
CREATE TABLE public.request_to_jemser_product_map
(
   id serial, 
   request_id integer, 
   jemser_product_id integer, 
   qty numeric(10,2), 
   comment text, 
   daily numeric(10,4), 
   day2 numeric(10,4), 
   day3 numeric(10,4), 
   day4 numeric(10,4), 
   day5 numeric(10,4), 
   day6 numeric(10,4), 
   weekly numeric(10,4), 
   CONSTRAINT req_to_jem_prod_map_pk PRIMARY KEY (id), 
   CONSTRAINT req_to_jem_prod_map_request_fk FOREIGN KEY (request_id) REFERENCES request (id) ON UPDATE NO ACTION ON DELETE NO ACTION, 
   CONSTRAINT req_to_jem_prod_map_jproduct_fk FOREIGN KEY (jemser_product_id) REFERENCES jemser_product (id) ON UPDATE NO ACTION ON DELETE NO ACTION
) 
WITH (
  OIDS = FALSE
)
;

CREATE TABLE mapping_document_type
(
  id integer NOT NULL,
  description text,
  CONSTRAINT mapping_document_type_pk PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE mapping_document_type
  OWNER TO postgres;
  

CREATE TABLE request_to_document_map
(
  id serial NOT NULL,
  request_id integer,
  mapping_document_type_id integer,
  document_number integer,
  document_id integer,
  business_entity_id integer,
  CONSTRAINT request_to_document_map_pk PRIMARY KEY (id),
  CONSTRAINT request_to_document_map_fk1 FOREIGN KEY (request_id)
      REFERENCES request (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT request_to_document_map_fk2 FOREIGN KEY (mapping_document_type_id)
      REFERENCES mapping_document_type (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT request_to_document_map_fk4 FOREIGN KEY (business_entity_id)
      REFERENCES business_entity (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE request_to_document_map
  OWNER TO postgres;
  
 ALTER TABLE request_to_jemser_product_map
  ADD COLUMN crosshire boolean;
ALTER TABLE request_to_jemser_product_map
  ADD COLUMN overridedescription text;
  
  
  ALTER TABLE request_to_jemser_product_map
  ADD COLUMN line_number integer;
ALTER TABLE request_to_jemser_product_map
  ADD COLUMN package_name text;
ALTER TABLE request_to_jemser_product_map
  ADD COLUMN package_seq integer;

  
  
CREATE TABLE document_bean_queue
(
  id serial NOT NULL,
  status integer,
  document_bean text,
  CONSTRAINT document_bean_queue_pk PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE document_bean_queue
  OWNER TO postgres;

-- 30/03/2017
ALTER TABLE request_to_jemser_product_map  ADD COLUMN qty_collected numeric(10,2);
ALTER TABLE request_to_jemser_product_map  ADD COLUMN qty_available numeric(10,2);

--04/04/2017
ALTER TABLE request ADD COLUMN request_id integer;
ALTER TABLE request ADD CONSTRAINT request_id_to_request_fkey FOREIGN KEY (request_id) REFERENCES request (id)
ON UPDATE NO ACTION ON DELETE NO ACTION;
CREATE INDEX fki_request_id_to_request_fkey
  ON request(request_id);

--18/04/2017
ALTER TABLE business_entity_to_address_map
  ADD COLUMN business_entity_to_address_map_id integer;
ALTER TABLE business_entity_to_address_map
  ADD COLUMN reference text;
ALTER TABLE business_entity_to_address_map
  ADD CONSTRAINT betam_betam_fk FOREIGN KEY (business_entity_to_address_map_id) REFERENCES business_entity_to_address_map (id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--02/05/2017
insert into person_role values (1005, 'Patient');
insert into contact_detail_category values (1005, 'Patient Number');
CREATE TABLE request_to_patient_map
(
   id serial, 
   request_id integer, 
   patient_id integer, 
   CONSTRAINT request_to_person_map_pkey PRIMARY KEY (id) USING INDEX TABLESPACE pg_default, 
   CONSTRAINT patient_id_to_person_fkey FOREIGN KEY (patient_id) REFERENCES person (id) ON UPDATE NO ACTION ON DELETE NO ACTION, 
   CONSTRAINT request_id_to_request_fkey FOREIGN KEY (request_id) REFERENCES request (id) ON UPDATE NO ACTION ON DELETE NO ACTION
) 
WITH (
  OIDS = FALSE
)
;
ALTER TABLE public.request_to_patient_map
  OWNER TO postgres;

--03/05/2017
ALTER TABLE document_bean_queue  ADD COLUMN request_id integer;
ALTER TABLE document_bean_queue  ADD COLUMN error_text text;
ALTER TABLE document_bean_queue  ADD COLUMN queue_type integer;

--05/05/2017
insert into action_type values ( 2015,'Verify Collection'); 

--07/05/2017
insert into request_type values ( 2007,'Return' );
ALTER TABLE request_to_jemser_product_map  ADD COLUMN from_date time with time zone;
ALTER TABLE request_to_jemser_product_map  ADD COLUMN to_date time with time zone;
ALTER TABLE request_to_jemser_product_map  ADD COLUMN detailline_id integer;

--08/05/2017

CREATE TABLE public.chead_to_person_map
(
   id serial, 
   person_id integer, 
   chead_location integer, 
   chead_contract integer, 
   reference text, 
   CONSTRAINT cheadtopersonmappk PRIMARY KEY (id), 
   CONSTRAINT chtopfk1 FOREIGN KEY (person_id) REFERENCES person (id) ON UPDATE NO ACTION ON DELETE NO ACTION, 
   CONSTRAINT chtopfk2 FOREIGN KEY (chead_location, chead_contract) REFERENCES chead (location, contract) ON UPDATE NO ACTION ON DELETE NO ACTION
) 
WITH (
  OIDS = FALSE
)
;

CREATE TABLE public.cust_order_to_person_map
(
   id serial, 
   person_id integer, 
   cust_order_id integer, 
   reference text, 
   CONSTRAINT custordertopersonmappk PRIMARY KEY (id), 
   CONSTRAINT cotopfk1 FOREIGN KEY (person_id) REFERENCES person (id) ON UPDATE NO ACTION ON DELETE NO ACTION, 
   CONSTRAINT cotopfk2 FOREIGN KEY (cust_order_id) REFERENCES cust_order (nsuk) ON UPDATE NO ACTION ON DELETE NO ACTION
) 
WITH (
  OIDS = FALSE
)
;

