﻿-- Function: create_jemser_business_entities()

-- DROP FUNCTION create_jemser_business_entities();

CREATE OR REPLACE FUNCTION create_jemser_business_entities_verify_mapping(company_id integer)
  RETURNS void AS
$BODY$
declare cust_row	cust%rowtype;
	operator_row 	operator%rowtype;
	contact_row	contact%rowtype;
	custsite_row	custsite%rowtype;
	custsite_ext_row custsite_ext%rowtype;
	
	cust_id		integer;
	address_id 	integer;
	person_id	integer;
	contact_detail_id integer;
	business_entity_to_person_map_id integer;
	
	Pcount		integer;
	personMap	person_to_contact_map%rowtype;
	businessEntityMap business_entity_to_cust_map%rowtype;
	addressMap	address_to_custsite_map%rowtype;
	err		sp_status;

begin

	    --company_id = 1769;
		
	    raise notice 'Create Primary Company Person';

	    for operator_row in 
		select * from operator
		order by cod
	    loop
	        select *
	        into personMap
	        from person_to_contact_map 
	        where contact_id = operator_row.cod
			and company_entity_id = company_id;

	        if not found then 
			raise notice 'Create Person';
			insert into person (name,photo,optlock) values ( operator_row.username,'photo',0 ) returning id into person_id;

			raise notice 'Create Person to Contact Map';
			insert into person_to_contact_map(person_id,contact_id,company_entity_id) values (person_id,operator_row.cod,company_id);

			raise notice 'Create Business Entity to Person Map';
			insert into business_entity_to_person_map (business_entity_id ,person_id,person_role_id,active) values (company_id,person_id,1004,true) returning id into business_entity_to_person_map_id;

			raise notice 'Create Person Contact Details';
			insert into contact_detail (contact_detail_category_id,detail_data) values (1000,operator_row.email) returning id into contact_detail_id; -- Email contact Detail.

			raise notice 'Create Person to Contact Detail Map';
			insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);

			raise notice 'Create Person Credentials';
			insert into person_credentials values(default,operator_row.email,operator_row.pswd,null,person_id);
	        else 

	                -- some explaining, its possible that the contact_id code could actually be from a customer , so we check if the person we find mapped
		        -- is the primary company , if not then we can create the mapping
				
			perform *
			from business_entity_to_person_map
			where business_entity_id = company_id
			and business_entity_to_person_map.person_id = personMap.person_id;

			if not found then
				raise notice 'Create Person';
				insert into person (name,photo,optlock) values ( operator_row.username,'photo',0 ) returning id into person_id;

				raise notice 'Create Person to Contact Map';
				insert into person_to_contact_map(person_id,contact_id,company_entity_id) values (person_id,operator_row.cod,company_id);

				raise notice 'Create Business Entity to Person Map';
				insert into business_entity_to_person_map (business_entity_id ,person_id,person_role_id,active) values (company_id,person_id,1004,true) returning id into business_entity_to_person_map_id;

				raise notice 'Create Person Contact Details';
				insert into contact_detail (contact_detail_category_id,detail_data) values (1000,operator_row.email) returning id into contact_detail_id; -- Email contact Detail.

				raise notice 'Create Person to Contact Detail Map';
				insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);

				raise notice 'Create Person Credentials';
				insert into person_credentials values(default,operator_row.email,operator_row.pswd,null,person_id);

			end if;


	        end if;
	        
	    end loop;
    

    
    
    
    for cust_row in 
       select * from cust 
       order by id
    loop

       select * 
       into businessEntityMap
       from business_entity_to_cust_map
       where business_entity_to_cust_map.cust_id = cust_row.id
	   and company_entity_id = company_id;

       if not found then
		
	       raise notice 'Create Business Entity';
		       insert into business_entity (business_entity_id,optlock,logo,lft,rgt,name) values(null,0,'logo',null,null,cust_row.nam) 
		       returning id into cust_id;

	       raise notice 'Create Business Entity to Cust Map';
		       insert into business_entity_to_cust_map ( business_entity_id,cust_id,customer_code ,company_entity_id) values ( cust_id,cust_row.id,cust_row.cod ,company_id );

	       raise notice 'Create Business Entity Relationship';

			insert into business_entity_relationship (source_business_entity_id,business_entity_category_id,target_business_entity_id) values(cust_id,1001,company_id);

	       raise notice 'Create Business Entity Address';
			
		       if cust_row.add1 is null then
				cust_row.add1 = '';
			end if;
			if cust_row.add2 is null then
				cust_row.add2 = '';
			end if;
			if cust_row.add3 is null then
				cust_row.add3 = '';
			end if;
			if cust_row.add4 is null then
				cust_row.add4 = '';
			end if;
		       insert into address (description,lat,lng,optlock,postcode) values (cust_row.add1||E'\n'||cust_row.add2||E'\n'||cust_row.add3||E'\n'||cust_row.add4,null,null,0,'postcode') 
		       returning id into address_id;

		       raise notice 'Create Business Entity to Address Map For Main Address';

	               insert into business_entity_to_address_map (business_entity_id,address_id,address_category_id,active) values(cust_id,address_id,1000,true); -- company address
       end if;

       
      
       
	       for custsite_row in 
		   select * from custsite
		   where depot = cust_row.depot
		   and  cust = cust_row.cod
		   order by site
	       loop


	                select * 
	                into addressMap
	                from address_to_custsite_map
	                where custsite_id = custsite_row.id
					and company_entity_id = company_id;
	                
	                if not found then
				raise notice 'Create Business Entity Site Address';

				select * 
				into custsite_ext_row
				from custsite_ext;

				if not found then 
				    custsite_ext_row.lat = null;
				    custsite_ext_row.lng = null;
				end if;

				if custsite_row.description is null then
					custsite_row.description = '';
				end if;
				if custsite_row.add1 is null then
					custsite_row.add1 = '';
				end if;
				if custsite_row.add2 is null then
					custsite_row.add2 = '';
				end if;
				if custsite_row.add3 is null then
					custsite_row.add3 = '';
				end if;
				if custsite_row.add4 is null then
					custsite_row.add4 = '';
				end if;

				
				insert into address (description,lat,lng,optlock,postcode,name) values( custsite_row.description ||E'\n'|| custsite_row.add1 ||E'\n'||custsite_row.add2||E'\n'||custsite_row.add3||E'\n'||custsite_row.add4 ,custsite_ext_row.lat,custsite_ext_row.lng,0,'postcode',custsite_row.description ) 
				returning id into address_id;

				raise notice 'Create Address to Custsite Map';
				insert into address_to_custsite_map  (address_id,custsite_id,company_entity_id) values ( address_id , custsite_row.id,company_id );
				
				raise notice 'Create Business Entity to Address Map For Site';
				if( cust_id is null ) then
				    insert into business_entity_to_address_map (business_entity_id,address_id,address_category_id,active) values(businessEntityMap.business_entity_id,address_id,1001,true);
				else 
			            insert into business_entity_to_address_map (business_entity_id,address_id,address_category_id,active) values(cust_id,address_id,1001,true); -- site address
				end if;

			end if;
			
	       end loop;
       

      

		for contact_row in 
			select * from contact
			where depot = cust_row.depot
			and   cod   = cust_row.cod
			order by nsuk
		    loop

			select *
			into personMap
			from person_to_contact_map 
			where contact_id = contact_row.nsuk
			and company_entity_id = company_id;

			if not found then 

		    
				raise notice 'Create Person';
				insert into person (name,photo,optlock) values ( contact_row.nam,'photo',0 ) returning id into person_id;

				raise notice 'Create Person to Contact Map';
				insert into person_to_contact_map(person_id,contact_id,company_entity_id) values (person_id,contact_row.nsuk,company_id);
					
				raise notice 'Create Business Entity to Person Map';

				if( cust_id is null ) then
			           insert into business_entity_to_person_map (business_entity_id ,person_id,person_role_id,active) values (businessEntityMap.business_entity_id,person_id,1004,true) returning id into business_entity_to_person_map_id;
				else
				   insert into business_entity_to_person_map (business_entity_id ,person_id,person_role_id,active) values (cust_id,person_id,1004,true) returning id into business_entity_to_person_map_id;
				end if;
				
				raise notice 'Create Person Contact Details (Email)';
				insert into contact_detail (contact_detail_category_id,detail_data) values (1000,contact_row.email) returning id into contact_detail_id; -- Email contact Detail.
				raise notice 'Create Person to Contact Detail Map (Email)';
				insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);

				raise notice 'Create Person Contact Details (Phone)';
				insert into contact_detail (contact_detail_category_id,detail_data) values (1001,contact_row.phone) returning id into contact_detail_id; -- Phone contact Detail.
				raise notice 'Create Person to Contact Detail Map (Phone)';
				insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);

				raise notice 'Create Person Contact Details (Fax)';
				insert into contact_detail (contact_detail_category_id,detail_data) values (1003,contact_row.fax) returning id into contact_detail_id; -- Fax contact Detail.
				raise notice 'Create Person to Contact Detail Map (Fax)';
				insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);

		        else 
		                -- some explaining, its possible that the contact_id code could actually be from the primary company , so we check if the person we find is mapped
		                -- to the primary company , if so then we can create the mapping for a customer as well
		                
				perform *
				from business_entity_to_person_map
				where business_entity_id = company_id
				and business_entity_to_person_map.person_id = personMap.person_id;

				if found then
					raise notice 'Create Person';
					insert into person (name,photo,optlock) values ( contact_row.nam,'photo',0 ) returning id into person_id;

					raise notice 'Create Person to Contact Map';
					insert into person_to_contact_map(person_id,contact_id,company_entity_id) values (person_id,contact_row.nsuk,company_id);
						
					raise notice 'Create Business Entity to Person Map';

					if( cust_id is null ) then
						insert into business_entity_to_person_map (business_entity_id ,person_id,person_role_id,active) values (businessEntityMap.business_entity_id,person_id,1004,true) returning id into business_entity_to_person_map_id;
					else
					   insert into business_entity_to_person_map (business_entity_id ,person_id,person_role_id,active) values (cust_id,person_id,1004,true) returning id into business_entity_to_person_map_id;
					end if;
					raise notice 'Create Person Contact Details (Email)';
					insert into contact_detail (contact_detail_category_id,detail_data) values (1000,contact_row.email) returning id into contact_detail_id; -- Email contact Detail.
					raise notice 'Create Person to Contact Detail Map (Email)';
					insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);

					raise notice 'Create Person Contact Details (Phone)';
					insert into contact_detail (contact_detail_category_id,detail_data) values (1001,contact_row.phone) returning id into contact_detail_id; -- Phone contact Detail.
					raise notice 'Create Person to Contact Detail Map (Phone)';
					insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);

					raise notice 'Create Person Contact Details (Fax)';
					insert into contact_detail (contact_detail_category_id,detail_data) values (1003,contact_row.fax) returning id into contact_detail_id; -- Fax contact Detail.
					raise notice 'Create Person to Contact Detail Map (Fax)';
					insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);

				end if;

		        end if;

		    end loop;
       	
    end loop;

    --err.ret_stat = 0;
    --err.ret_string := 'Success';

    --return err;


end;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION create_jemser_business_entities_verify_mapping(company_id integer)
  OWNER TO postgres;

select * from business_entity order by id desc

select * from address order by id desc


select  * from business_entity_to_address_map order by id desc
update business_entity_to_address_map set business_entity_id = 2757 where id in (  8866 )


select * from business_entity_to_cust_map where business_entity_id = 2291


select * from address_to_custsite_map where address_id is null order by id desc 

select * from person_to_contact_map where person_id is null order by id desc

select * from hirecustsite where id = 812


select * from hirecust where cod = 'BRE0001'


select * from cust where upper(nam) like upper('%Test Customer%')

select * from business_entity where upper(name) like upper('%Bretland Construction Ltd.%')

select  * from business_entity_to_person_map as betpm join person 
					as p on (betpm.person_id = p.id) where betpm.business_entity_id = 2291 and upper(p.name) = upper('Hilary /Shirley');

select * from business_entity_to_person_map where business_entity_id = 2291

select * from person where id = 3663

select * from person where id = 
select * from hirecontact where cod = 'BRE0001'

select * from contact where cod = 'BRE0001'


select * from person order by id desc

select * from create_jemser_business_entities_verify_mapping()



select * from person_to_contact_map order by id desc


select * from custsite where id = 1950

select * from business_entity_to_cust_map where cod = 'ST 0003


select * from address_to_custsite_map where address_id is null


select * from business_entity_to_person_map where person_id = 4083

select * from business_entity where id = 2731

select * from business_entity_to_cust_map where business_entity_id = 2731
select * from hirecontact where cod = 'SHA0001'

select * from person where id = 4083


select * from jemser_product_to_hire_or_product_map  where product_type_id is not null