﻿-- Function: create_or_merge_jemser_business_entities(integer, integer)

-- DROP FUNCTION create_or_merge_jemser_business_entities(integer, integer);

CREATE OR REPLACE FUNCTION create_or_merge_jemser_business_entities(primarycompany_id integer, newcompany_id integer)
  RETURNS void AS
$BODY$
declare cust_row	remotehirecust%rowtype;
	operator_row 	operator%rowtype;
	contact_row		remotehirecontact%rowtype;
	custsite_row	remotehirecustsite%rowtype;
	custsite_ext_row remote_custsite_ext%rowtype;
	businessEntityMap business_entity_to_cust_map%rowtype;
	businessEntityToPersonMap business_entity_to_person_map%rowtype;
	addressToCustsiteMap address_to_custsite_map%rowtype;
	personMap	person_to_contact_map%rowtype;
	
	addressMap	address_to_custsite_map%rowtype;
	cust_id		integer;
	company_id	integer;
	address_id_var 	integer;
	address_id      integer;
	person_id	integer;
	contact_detail_id integer;
	business_entity_to_person_map_id integer;
	Pcount		integer;
	err		sp_status;
	old_cust_id 	integer;

begin

        
    for cust_row in 
       select * from remotehirecust 
       order by id
    loop

		perform * from business_entity where upper(name) = upper(cust_row.nam);
	   if found THEN
		 --raise notice 'Business Entity EXISTS';
			old_cust_id = cust_row.id;
			--company_id = id;
			company_id = (select id from business_entity where upper(name) = upper(cust_row.nam));


			-- todo , need to add mapping info for this business_entity for newcompany
			


			select * 
		       into businessEntityMap
		       from business_entity_to_cust_map
		       where business_entity_to_cust_map.cust_id = cust_row.id
		       and business_entity_to_cust_map.company_entity_id = newcompany_id;
		       if not found then
		       raise notice 'Create Business Entity to Cust Map';
				insert into business_entity_to_cust_map ( business_entity_id,cust_id,customer_code ,company_entity_id) values ( company_id,cust_row.id,cust_row.cod ,newcompany_id );
		       end if;
			
			for contact_row in 
			select * from remotehirecontact 
			where cod = cust_row.cod 
							
			loop
					--raise notice 'looping through contacts';
					select count(*) into Pcount from business_entity_to_person_map as betpm join person 
					as p on (betpm.person_id = p.id) where betpm.business_entity_id = company_id and upper(p.name) = upper(contact_row.nam);
						if Pcount > 0  THEN
								--raise notice 'person exists';
						       select betpm.person_id 
						       into person_id
						       from business_entity_to_person_map as betpm join person 
							as p on (betpm.person_id = p.id) 
							where betpm.business_entity_id = company_id and upper(p.name) = upper(contact_row.nam) limit 1;
								-- need to add mapping info for this person for newcompany
							


								
							select *
							into personMap
							from person_to_contact_map 
							where contact_id = contact_row.nsuk
							and person_to_contact_map.company_entity_id = newcompany_id;
							
							if not found then
							raise notice 'Create Person to Contact Map';
								insert into person_to_contact_map(person_id,contact_id,company_entity_id) values (person_id,contact_row.nsuk,newcompany_id);
							end if;
								
						else
							select *
							into personMap
							from person_to_contact_map 
							where contact_id = contact_row.nsuk
							and person_to_contact_map.company_entity_id = newcompany_id;
							
							if not found then
								raise notice 'Creating person';
								insert into person (name,photo,optlock) values ( contact_row.nam,'photo',0 ) returning id into person_id;

								raise notice 'Create Person to Contact Map';
								insert into person_to_contact_map(person_id,contact_id,company_entity_id) values (person_id,contact_row.nsuk,newcompany_id);
									
								raise notice 'Create Business Entity to Person Map';
								insert into business_entity_to_person_map (business_entity_id ,person_id,person_role_id,active) values (company_id,person_id,1004,true) returning id into business_entity_to_person_map_id;

								raise notice 'Create Person Contact Details (Email)';
								insert into contact_detail (contact_detail_category_id,detail_data) values (1000,contact_row.email) returning id into contact_detail_id; -- Email contact Detail.
								raise notice 'Create Person to Contact Detail Map (Email)';
								insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);

								raise notice 'Create Person Contact Details (Phone)';
								insert into contact_detail (contact_detail_category_id,detail_data) values (1001,contact_row.phone) returning id into contact_detail_id; -- Phone contact Detail.
								raise notice 'Create Person to Contact Detail Map (Phone)';
								insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);

								raise notice 'Create Person Contact Details (Fax)';
								insert into contact_detail (contact_detail_category_id,detail_data) values (1003,contact_row.fax) returning id into contact_detail_id; -- Fax contact Detail.
								raise notice 'Create Person to Contact Detail Map (Fax)';
								insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);
							end if;
						end if;
					
			end loop;
			
			for custsite_row in 
			select * from remotehirecustsite 
			where cust = cust_row.cod
					loop
					
							--raise notice 'looping through sites';
							select count(*) into Pcount from business_entity_to_address_map as betam join address  as a on 
							(betam.address_id = a.id) where betam.business_entity_id = company_id and upper(a.description) = upper(custsite_row.add1||E'\n'||custsite_row.add2||E'\n'||custsite_row.add3||E'\n'||custsite_row.add4); 
								if Pcount > 0 THEN
										--raise notice 'address exists %' , custsite_row.add1||E'\n'||custsite_row.add2||E'\n'||custsite_row.add3||E'\n'||custsite_row.add4  ;
										select betam.address_id 
										into address_id_var
										from business_entity_to_address_map as betam join address  as a on 
										(betam.address_id = a.id) where betam.business_entity_id = company_id and upper(a.description) = upper(custsite_row.add1||E'\n'||custsite_row.add2||E'\n'||custsite_row.add3||E'\n'||custsite_row.add4) 
									        limit 1;
										-- todo need to add mapping for address for newcompany 
										

										select * 
										into addressMap
										from address_to_custsite_map
										where custsite_id = custsite_row.id
										and address_to_custsite_map.company_entity_id = newcompany_id;
										if not found then 
											raise notice 'Create Address to Custsite Map';
											insert into address_to_custsite_map  (address_id,custsite_id,company_entity_id) values ( address_id_var , custsite_row.id , newcompany_id );
									        end if;
											
									       
										perform * 
										from business_entity_to_address_map  
										where business_entity_id = company_id
										and business_entity_to_address_map.address_id = address_id_var;
										
										if not found then 
										         raise notice 'Create Business Entity to Address Map For Site';
											insert into business_entity_to_address_map (business_entity_id,address_id,address_category_id,active) values(company_id,address_id_var,1001,true); -- site address
										end if;
											
								else
										--raise notice 'Address does not exists %' , custsite_row.add1||E'\n'||custsite_row.add2||E'\n'||custsite_row.add3||E'\n'||custsite_row.add4  ; 
										select * 
										into addressMap
										from address_to_custsite_map
										where custsite_id = custsite_row.id
										and address_to_custsite_map.company_entity_id = newcompany_id;
										if not found then 
										raise notice 'creating address';
												select * 
												into custsite_ext_row
												from remote_custsite_ext;

												if not found then 
														custsite_ext_row.lat = null;
														custsite_ext_row.lng = null;
												end if;

													if custsite_row.description is null then
													custsite_row.description = '';
												end if;
												if custsite_row.add1 is null then
													custsite_row.add1 = '';
												end if;
												if custsite_row.add2 is null then
													custsite_row.add2 = '';
												end if;
												if custsite_row.add3 is null then
													custsite_row.add3 = '';
												end if;
												if custsite_row.add4 is null then
													custsite_row.add4 = '';
												end if;

												
												insert into address (description,lat,lng,optlock,postcode,name) values( custsite_row.description ||E'\n'|| custsite_row.add1 ||E'\n'||custsite_row.add2||E'\n'||custsite_row.add3||E'\n'||custsite_row.add4 ,custsite_ext_row.lat,custsite_ext_row.lng,0,'postcode',custsite_row.description ) 
												returning id into address_id;

													raise notice 'Create Address to Custsite Map';
													insert into address_to_custsite_map  (address_id,custsite_id,company_entity_id) values ( address_id , custsite_row.id , newcompany_id );
											
												raise notice 'Create Business Entity to Address Map For Site';
												insert into business_entity_to_address_map (business_entity_id,address_id,address_category_id,active) values(company_id,address_id,1001,true); -- site address
											end if;
												
										
								end if;
					
					end loop;
					
			
				
			
	   else
		   raise notice 'NEW Business Entity % %',cust_row.nam , cust_row.id;
	       cust_id = 0;
	       select * 
	       into businessEntityMap
	       from business_entity_to_cust_map
	       where business_entity_to_cust_map.cust_id = cust_row.id
	       and business_entity_to_cust_map.company_entity_id = newcompany_id;
	       if not found then
	   
			raise notice 'Create Business Entity';
			
		       insert into business_entity (business_entity_id,optlock,logo,lft,rgt,name) values(null,0,'logo',null,null,cust_row.nam) 
		       returning id into cust_id;

		       raise notice 'Create Business Entity to Cust Map';
			       insert into business_entity_to_cust_map ( business_entity_id,cust_id,customer_code ,company_entity_id) values ( cust_id,cust_row.id,cust_row.cod,newcompany_id );

		       raise notice 'Create Business Entity Relationship';

			   --------------------------------------------------------------------------------
			   ----- Hardcoded last value to primary company make sure to do the same!!!!!!----
			   --------------------------------------------------------------------------------
			insert into business_entity_relationship (source_business_entity_id,business_entity_category_id,target_business_entity_id) values(cust_id,1001, primarycompany_id );

		       raise notice 'Create Business Entity Address';
				
			       if cust_row.add1 is null then
					cust_row.add1 = '';
				end if;
				if cust_row.add2 is null then
					cust_row.add2 = '';
				end if;
				if cust_row.add3 is null then
					cust_row.add3 = '';
				end if;
				if cust_row.add4 is null then
					cust_row.add4 = '';
				end if;
			       insert into address (description,lat,lng,optlock,postcode) values (cust_row.add1||E'\n'||cust_row.add2||E'\n'||cust_row.add3||E'\n'||cust_row.add4,null,null,0,'postcode') 
			       returning id into address_id;

			       raise notice 'Create Business Entity to Address Map For Main Address';

				       insert into business_entity_to_address_map (business_entity_id,address_id,address_category_id,active) values(cust_id,address_id,1000,true); -- company address

				raise notice 'Create Business Entity Site Address';
		       
			       for custsite_row in 
				   select * from remotehirecustsite
				   where depot = cust_row.depot
				   and  cust = cust_row.cod
				   order by site
			       loop
					raise notice 'Create Business Entity Site Address';

					select * 
					into custsite_ext_row
					from remote_custsite_ext;

					if not found then 
					    custsite_ext_row.lat = null;
					    custsite_ext_row.lng = null;
					end if;

					if custsite_row.description is null then
						custsite_row.description = '';
					end if;
					if custsite_row.add1 is null then
						custsite_row.add1 = '';
					end if;
					if custsite_row.add2 is null then
						custsite_row.add2 = '';
					end if;
					if custsite_row.add3 is null then
						custsite_row.add3 = '';
					end if;
					if custsite_row.add4 is null then
						custsite_row.add4 = '';
					end if;

					
					insert into address (description,lat,lng,optlock,postcode,name) values( custsite_row.description ||E'\n'|| custsite_row.add1 ||E'\n'||custsite_row.add2||E'\n'||custsite_row.add3||E'\n'||custsite_row.add4 ,custsite_ext_row.lat,custsite_ext_row.lng,0,'postcode',custsite_row.description ) 
					returning id into address_id;

					raise notice 'Create Address to Custsite Map';
					insert into address_to_custsite_map  (address_id,custsite_id,company_entity_id) values ( address_id , custsite_row.id, newcompany_id );
				
					raise notice 'Create Business Entity to Address Map For Site';

					if( cust_id = 0 ) then
						insert into business_entity_to_address_map (business_entity_id,address_id,address_category_id,active) values(businessEntityMap.business_entity_id,address_id,1001,true); -- site address
					else
						insert into business_entity_to_address_map (business_entity_id,address_id,address_category_id,active) values(cust_id,address_id,1001,true); -- site address
					end if;
					
			       end loop;
	    end if;
       
		for contact_row in 
			select * from remotehirecontact
			where depot = cust_row.depot
			and   cod   = cust_row.cod
			order by nsuk
		    loop

			
		        select *
			into personMap
			from person_to_contact_map 
			where contact_id = contact_row.nsuk
			and person_to_contact_map.company_entity_id = newcompany_id;
			
			if not found then
				raise notice 'Create Person';
				insert into person (name,photo,optlock) values ( contact_row.nam,'photo',0 ) returning id into person_id;

				raise notice 'Create Person to Contact Map';
				insert into person_to_contact_map(person_id,contact_id,company_entity_id) values (person_id,contact_row.nsuk,newcompany_id);
					
				raise notice 'Create Business Entity to Person Map';

				if( cust_id = 0 ) then
					insert into business_entity_to_person_map (business_entity_id ,person_id,person_role_id,active) values (businessEntityMap.business_entity_id,person_id,1004,true) returning id into business_entity_to_person_map_id;
				else
					insert into business_entity_to_person_map (business_entity_id ,person_id,person_role_id,active) values (cust_id,person_id,1004,true) returning id into business_entity_to_person_map_id;
				end if;
				raise notice 'Create Person Contact Details (Email)';
				insert into contact_detail (contact_detail_category_id,detail_data) values (1000,contact_row.email) returning id into contact_detail_id; -- Email contact Detail.
				raise notice 'Create Person to Contact Detail Map (Email)';
				insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);

				raise notice 'Create Person Contact Details (Phone)';
				insert into contact_detail (contact_detail_category_id,detail_data) values (1001,contact_row.phone) returning id into contact_detail_id; -- Phone contact Detail.
				raise notice 'Create Person to Contact Detail Map (Phone)';
				insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);

				raise notice 'Create Person Contact Details (Fax)';
				insert into contact_detail (contact_detail_category_id,detail_data) values (1003,contact_row.fax) returning id into contact_detail_id; -- Fax contact Detail.
				raise notice 'Create Person to Contact Detail Map (Fax)';
				insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);
			end if;
		end loop;
       	end if;
    end loop;

    --err.ret_stat = 0;
    --err.ret_string := 'Success';

    --return err;


end;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION create_or_merge_jemser_business_entities(integer, integer)
  OWNER TO postgres;
