﻿-- Function: create_jemser_products(integer)

-- DROP FUNCTION create_jemser_products(integer);

CREATE OR REPLACE FUNCTION create_jemser_products_update(company_id integer)
  RETURNS void AS
$BODY$
declare hire_dept_row	hire_dept%rowtype;
	hire_dept_group_row 	hire_dept_group%rowtype;
	dept_row	dept%rowtype;
	dept_group_row	dept_group%rowtype;

	pdesc_row       pdesc%rowtype;
	singles_row     singles%rowtype;

	product_row	product%rowtype;
	product_type_row product_type%rowtype;
	
	hire_dept_id 	integer;
	hire_dept_group_id integer;
	jemser_product_pdesc_id integer;
	jemser_product_single_id integer;

	dept_id		integer;
	dept_group_id	integer;
	jemser_product_product_id integer;
	jemser_product_product_type_id integer;
    stock_row 			stock%rowtype;
	
	Pcount		integer;
	err		sp_status;

begin


    for hire_dept_row in
    select * from hire_dept
    order by descr
    loop
        --raise notice 'Create Hire Dept  %' , hire_dept_row.descr ;


	select id 
	into hire_dept_id
	from product_group
	where description = hire_dept_row.descr
	and product_class_id = 4 -- rental
	and product_group_id is null; -- dept 

	if not found then
		raise notice 'creating dept %',hire_dept_row.descr;
		insert into product_group values ( default, hire_dept_row.descr,null,0,null,null,null,4 ) returning id into hire_dept_id; -- 4 is equipment type , marks the group as rental

	end if;

	
        for hire_dept_group_row in 
        select * from hire_dept_group
        where hire_dept  = hire_dept_row.nsuk
        order by descr
        loop

		select id 
		into hire_dept_group_id
		from product_group
		where description = hire_dept_group_row.descr
		and product_class_id = 4 -- rental
		and product_group_id is not  null; -- dept_goup 

		if not found then
			raise notice 'Create Hire Dept Group %' , hire_dept_group_row.descr ;
			insert into product_group values ( default, hire_dept_group_row.descr, hire_dept_id ,0,null,null,null,4 ) returning id into hire_dept_group_id; -- 4 is equipment type , marks the group as rental
		end if;

            
	    

	    for pdesc_row in 
	    select p.* from pdesc p
	    join pdesc_ext pe on ( pe.dept_group = hire_dept_group_row.nsuk and pe.pdesc  = p.cod )
	    order by p.cod
	    loop




	    
		--raise notice 'Create Pdesc %' , pdesc_row.cod;

		if pdesc_row.desc1 is null then
			pdesc_row.desc1 = '';
		end if;
		if pdesc_row.desc2 is null then
			pdesc_row.desc2 = '';
		end if;
		if pdesc_row.desc3 is null then
			pdesc_row.desc3 = '';
		end if;
		
		
		if( pdesc_row.typ = 'M' ) then

			select jemser_product_id
			into jemser_product_pdesc_id
			from jemser_product_to_hire_or_product_map
			where pdesc_id = pdesc_row.id
			and business_entity_id = company_id;

			if not found then
				raise notice 'Creating Multiple pdesc % ',pdesc_row.cod;
				insert into jemser_product values ( default, pdesc_row.desc1 ||E'\n'|| pdesc_row.desc2 || E'\n' || pdesc_row.desc3,null,0,hire_dept_group_id,null,null,2 ,pdesc_row.cod ) returning id into jemser_product_pdesc_id;
				insert into jemser_product_to_hire_or_product_map values ( default,jemser_product_pdesc_id,null,pdesc_row.id ,company_id,null);
				insert into business_entity_product values (default,company_id,0,jemser_product_pdesc_id,null,null);	
			end if ;
			
		else

			select jemser_product_id
			into jemser_product_pdesc_id
			from jemser_product_to_hire_or_product_map
			where pdesc_id = pdesc_row.id
			and business_entity_id = company_id
                        and singles_id is null;

			if not found then
				raise notice 'Creating Single pdesc % ',pdesc_row.cod;
				insert into jemser_product values ( default, pdesc_row.desc1 ||E'\n'|| pdesc_row.desc2 || E'\n' || pdesc_row.desc3,null,0,hire_dept_group_id,null,null,4 ,pdesc_row.cod ) returning id into jemser_product_pdesc_id;
				insert into jemser_product_to_hire_or_product_map values ( default,jemser_product_pdesc_id,null,pdesc_row.id ,company_id,null);
				insert into business_entity_product values (default,company_id,0,jemser_product_pdesc_id,null,null);	
			end if;

			
			for singles_row in 
			select * from singles
			where pdesc = pdesc_row.cod
			order by cod
			loop

				select jemser_product_id
				into jemser_product_single_id
				from jemser_product_to_hire_or_product_map
				where singles_id = singles_row.id
				and business_entity_id = company_id;

				if not found then
			        
					raise notice 'Create Single Item %',singles_row.cod;

					insert into jemser_product values ( default, pdesc_row.desc1 ||E'\n'|| pdesc_row.desc2 || E'\n' || pdesc_row.desc3,jemser_product_pdesc_id ,0,hire_dept_group_id,null,null,1 ,singles_row.cod ) returning id into jemser_product_single_id;
					insert into jemser_product_to_hire_or_product_map values ( default,jemser_product_single_id,null,pdesc_row.id,company_id,singles_row.id );
					insert into business_entity_product values (default,company_id,0,jemser_product_single_id,null,null);	
				end if;
				
			end loop;
		end if;
		
	    end loop;
	    
        end loop;

    end loop;

for dept_row in
    select * from dept
    order by descr
    loop


        select id 
	into dept_id
	from product_group
	where description = dept_row.descr
	and product_class_id = 5
	and product_group_id is null; -- dept 

	if not found then
		raise notice 'Create Product Dept  %' , dept_row.descr ;

		insert into product_group values ( default, dept_row.descr,null,0,null,null,null,5 ) returning id into dept_id; -- 5 is Product , marks the group as consummable
	end if;

	
        for dept_group_row in 
        select * from dept_group
        where dept = dept_row.nsuk
        order by descr
        loop

            select id 
		into dept_group_id
		from product_group
		where description = dept_group_row.descr
		and product_class_id = 5
		and product_group_id is null; -- dept 

		if not found then
		    raise notice 'Create Product Dept Group %' , dept_group_row.descr ;
		    insert into product_group values ( default, dept_group_row.descr, dept_id ,0,null,null,null,5 ) returning id into dept_group_id; -- 5 is Product , marks the group as consummable
		end if;

        
	    for product_row in 
	    select p.* from product p
	    where dept_group = dept_group_row.nsuk
	    order by p.cod
	    
	    loop


		select jemser_product_id
			into jemser_product_product_id
			from jemser_product_to_hire_or_product_map
			where product_type_id = product_row.nsuk
			and business_entity_id = company_id;

			if not found then
				raise notice 'Create Product %' , product_row.cod;

				insert into jemser_product values ( default, product_row.description,null,0,dept_group_id,null,null,5 ,product_row.cod ) returning id into jemser_product_product_id;
				insert into jemser_product_to_hire_or_product_map values ( default,jemser_product_product_id,product_row.nsuk,null ,company_id,null);
				insert into business_entity_product values (default,company_id,0,jemser_product_product_id,null,null);	
			end if;

		
		for product_type_row in 
		select * from product_type
		where product = product_row.nsuk
		order by plu
		loop

		        select jemser_product_id
			into jemser_product_product_type_id
			from jemser_product_to_hire_or_product_map
			where product_type_id = product_type_row.nsuk
			and business_entity_id = company_id;

			if not found then
				raise notice 'Create Product_Type %',product_type_row.plu;

				insert into jemser_product values ( default, product_type_row.descr,jemser_product_product_id ,0,dept_group_id,null,null,6 ,product_type_row.plu ) returning id into jemser_product_product_type_id;
				insert into jemser_product_to_hire_or_product_map values ( default,jemser_product_product_type_id,product_type_row.nsuk,null ,company_id,null);
				insert into business_entity_product values (default,company_id,0,jemser_product_product_type_id,null,null);	
				
				-- now we make sure that the product_type has a stock row entry.
				
				select *
				into stock_row
				from stock
				where product_type = product_type_row.nsuk;
				if not found then
					insert into stock values ( default,product_type_row.nsuk,1,0.00,0.00,0.00,0.00,0.00,0.00 );
				end if;
				
			end if;
		end loop;
	
	    end loop;
	    
        end loop;

    end loop;






    
    
    
    
	    
    --err.ret_stat = 0;
    --err.ret_string := 'Success';

    --return err;


end;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION create_jemser_products_update(integer)
  OWNER TO postgres;


  select * from create_jemser_products_update(1769)
