﻿-- Function: create_rascor_products()

-- DROP FUNCTION create_rascor_products();

CREATE OR REPLACE FUNCTION create_jemser_business_entities()
  RETURNS void AS
$BODY$
declare cust_row	cust%rowtype;
	operator_row 	operator%rowtype;
	contact_row	contact%rowtype;
	custsite_row	custsite%rowtype;
	custsite_ext_row custsite_ext%rowtype;
	
	cust_id		integer;
	company_id	integer;
	address_id 	integer;
	person_id	integer;
	contact_detail_id integer;
	business_entity_to_person_map_id integer;
	Pcount		integer;
	err		sp_status;

begin

    raise notice 'Create Primary Company Entity'; 
    
    
	    insert into business_entity (business_entity_id,optlock,logo,lft,rgt,name) select null,0,'logo',null,null,nam from company 
	    returning id into company_id;

	    insert into address (description,lat,lng,optlock,postcode) select add1 ||E'\n'||add2||E'\n'||add3||E'\n'||add4 ,null,null,0,'postcode' from company
	    returning id into address_id;

	    insert into business_entity_to_address_map (business_entity_id,address_id,address_category_id,active) values(company_id,address_id,1000,true);

	    insert into business_entity_relationship (source_business_entity_id,business_entity_category_id,target_business_entity_id) values(company_id,1000,company_id); -- setup this as the primary company of business_entity. as it will be only row on this table with a category of 1 , primary 


	    raise notice 'Create Primary Company Person';

	    for operator_row in 
		select * from operator
		order by cod
	    loop
		raise notice 'Create Person';
		insert into person (name,photo,optlock) values ( operator_row.username,'photo',0 ) returning id into person_id;

		raise notice 'Create Business Entity to Person Map';
		insert into business_entity_to_person_map (business_entity_id ,person_id,person_role_id,active) values (company_id,person_id,1004,true) returning id into business_entity_to_person_map_id;

		raise notice 'Create Person Contact Details';
		insert into contact_detail (contact_detail_category_id,detail_data) values (1000,operator_row.email) returning id into contact_detail_id; -- Email contact Detail.
		raise notice 'Create Person to Contact Detail Map';
		insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);
		raise notice 'Create Person Credentials';
		insert into person_credentials values(default,operator_row.email,operator_row.pswd,null,person_id);

	    end loop;
    

    
    
    
    for cust_row in 
       select * from cust 
       order by id
    loop
      
       raise notice 'Create Business Entity';
	       insert into business_entity (business_entity_id,optlock,logo,lft,rgt,name) values(null,0,'logo',null,null,cust_row.nam) 
	       returning id into cust_id;

       raise notice 'Create Business Entity to Cust Map';
	       insert into business_entity_to_cust_map ( business_entity_id,cust_id,customer_code ) values ( cust_id,cust_row.id,cust_row.cod );

       raise notice 'Create Business Entity Relationship';

		insert into business_entity_relationship (source_business_entity_id,business_entity_category_id,target_business_entity_id) values(cust_id,1001,company_id);

       raise notice 'Create Business Entity Address';
		
	       if cust_row.add1 is null then
			cust_row.add1 = '';
		end if;
		if cust_row.add2 is null then
			cust_row.add2 = '';
		end if;
		if cust_row.add3 is null then
			cust_row.add3 = '';
		end if;
		if cust_row.add4 is null then
			cust_row.add4 = '';
		end if;
	       insert into address (description,lat,lng,optlock,postcode) values (cust_row.add1||E'\n'||cust_row.add2||E'\n'||cust_row.add3||E'\n'||cust_row.add4,null,null,0,'postcode') 
	       returning id into address_id;

       raise notice 'Create Business Entity to Address Map For Main Address';

	       insert into business_entity_to_address_map (business_entity_id,address_id,address_category_id,active) values(cust_id,address_id,1000,true); -- company address

       raise notice 'Create Business Entity Site Address';
       
	       for custsite_row in 
		   select * from custsite
		   where depot = cust_row.depot
		   and  cust = cust_row.cod
		   order by site
	       loop
			raise notice 'Create Business Entity Site Address';

			select * 
			into custsite_ext_row
			from custsite_ext;

			if not found then 
		            custsite_ext_row.lat = null;
		            custsite_ext_row.lng = null;
			end if;

		        if custsite_row.description is null then
				custsite_row.description = '';
			end if;
			if custsite_row.add1 is null then
				custsite_row.add1 = '';
			end if;
			if custsite_row.add2 is null then
				custsite_row.add2 = '';
			end if;
			if custsite_row.add3 is null then
				custsite_row.add3 = '';
			end if;
			if custsite_row.add4 is null then
				custsite_row.add4 = '';
			end if;

			
			insert into address (description,lat,lng,optlock,postcode,name) values( custsite_row.description ||E'\n'|| custsite_row.add1 ||E'\n'||custsite_row.add2||E'\n'||custsite_row.add3||E'\n'||custsite_row.add4 ,custsite_ext_row.lat,custsite_ext_row.lng,0,'postcode',custsite_row.description ) 
			returning id into address_id;

		        raise notice 'Create Address to Custsite Map';
		        insert into address_to_custsite_map  (address_id,custsite_id) values ( address_id , custsite_row.id );
		
			raise notice 'Create Business Entity to Address Map For Site';
			insert into business_entity_to_address_map (business_entity_id,address_id,address_category_id,active) values(cust_id,address_id,1001,true); -- site address

			
	       end loop;
       

       raise notice 'Create Business Entity Persons';

		for contact_row in 
			select * from contact
			where depot = cust_row.depot
			and   cod   = cust_row.cod
			order by nsuk
		    loop
			raise notice 'Create Person';
			insert into person (name,photo,optlock) values ( contact_row.nam,'photo',0 ) returning id into person_id;

			raise notice 'Create Person to Contact Map';
			insert into person_to_contact_map(person_id,contact_id) values (person_id,contact_row.nsuk);
				
			raise notice 'Create Business Entity to Person Map';
			insert into business_entity_to_person_map (business_entity_id ,person_id,person_role_id,active) values (cust_id,person_id,1004,true) returning id into business_entity_to_person_map_id;

			raise notice 'Create Person Contact Details (Email)';
			insert into contact_detail (contact_detail_category_id,detail_data) values (1000,contact_row.email) returning id into contact_detail_id; -- Email contact Detail.
			raise notice 'Create Person to Contact Detail Map (Email)';
			insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);

			raise notice 'Create Person Contact Details (Phone)';
			insert into contact_detail (contact_detail_category_id,detail_data) values (1001,contact_row.phone) returning id into contact_detail_id; -- Phone contact Detail.
			raise notice 'Create Person to Contact Detail Map (Phone)';
			insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);

			raise notice 'Create Person Contact Details (Fax)';
			insert into contact_detail (contact_detail_category_id,detail_data) values (1003,contact_row.fax) returning id into contact_detail_id; -- Fax contact Detail.
			raise notice 'Create Person to Contact Detail Map (Fax)';
			insert into person_to_contact_detail_map (person_id,contact_detail_id) values( person_id,contact_detail_id);

		    end loop;
       	
    end loop;

    --err.ret_stat = 0;
    --err.ret_string := 'Success';

    --return err;


end;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION create_jemser_business_entities()
  OWNER TO postgres;

  select * from create_jemser_business_entities();